﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace BajoGabor_Amoba_Form
{
    public partial class Form1 : Form
    {
        string elsonev;
        string masodiknev;
        char[] tabla = { '1', '2', '3', '4', '5', '6', '7', '8', '9' };
        int lepes = 0; /*hányadik lépésnél tart a játék, maximum 9 lehet*/
        char jel1; /*az aktuális játékos jele*/
        char jel2; /*a másik játékos jele*/
        int jatekos; /*hányadik játékos lép éppen*/
        string nev1; /*az aktuális játékos neve*/
        string nev2; /*a másik játékos neve*/
        int allas = 0; /*játék állása, 0=döntetlen, 1=első játékos nyert, 2=második játékos nyert*/
        int gombszam; /*melyik gombot nyomta meg az aktuális játékos*/

        public Form1()
        {
            InitializeComponent();
        }

        private void btnKezdes_Click(object sender, EventArgs e)
        {
            elsonev = txt1.Text;
            masodiknev = txt2.Text;
            btn0.Enabled = true;
            btn1.Enabled = true;
            btn2.Enabled = true;
            btn3.Enabled = true;
            btn4.Enabled = true;
            btn5.Enabled = true;
            btn6.Enabled = true;
            btn7.Enabled = true;
            btn8.Enabled = true;
            btnKezdes.Enabled = false;
            txt1.Enabled = false;
            txt2.Enabled = false;
            lblUzenet.Text = elsonev + " következik! (Jeled: X.)";
        }

        private void btn0_Click(object sender, EventArgs e)
        {
            gombszam = 0;
            Gomb(gombszam);            
            btn0.Enabled = false;
            btn0.Text = jel1.ToString();            
        }

        private void btn1_Click(object sender, EventArgs e)
        {
            gombszam = 1;
            Gomb(gombszam);
            btn1.Enabled = false;
            btn1.Text = jel1.ToString();
        }

        private void btn2_Click(object sender, EventArgs e)
        {
            gombszam = 2;
            Gomb(gombszam);
            btn2.Enabled = false;
            btn2.Text = jel1.ToString();
        }

        private void btn3_Click(object sender, EventArgs e)
        {
            gombszam = 3;
            Gomb(gombszam);
            btn3.Enabled = false;
            btn3.Text = jel1.ToString();
        }

        private void btn4_Click(object sender, EventArgs e)
        {
            gombszam = 4;
            Gomb(gombszam);
            btn4.Enabled = false;
            btn4.Text = jel1.ToString();
        }

        private void btn5_Click(object sender, EventArgs e)
        {
            gombszam = 5;
            Gomb(gombszam);
            btn5.Enabled = false;
            btn5.Text = jel1.ToString();
        }

        private void btn6_Click(object sender, EventArgs e)
        {
            gombszam = 6;
            Gomb(gombszam);
            btn6.Enabled = false;
            btn6.Text = jel1.ToString();
        }

        private void btn7_Click(object sender, EventArgs e)
        {
            gombszam = 7;
            Gomb(gombszam);
            btn7.Enabled = false;
            btn7.Text = jel1.ToString();
        }

        private void btn8_Click(object sender, EventArgs e)
        {
            gombszam = 8;
            Gomb(gombszam);
            btn8.Enabled = false;
            btn8.Text = jel1.ToString();
        }

        private void Gomb(int gombszam)
        {
            lepes++;
            if (lepes % 2 == 0)
            {
                jel1 = 'O';
                jel2 = 'X';
                nev1 = masodiknev;
                nev2 = elsonev;
                jatekos = 2;
            }
            else
            {
                jel1 = 'X';
                jel2 = 'O';
                nev1 = elsonev;
                nev2 = masodiknev;
                jatekos = 1;
            }
            tabla[gombszam] = jel1;
            if (lepes > 4)
            {
                if (tabla[0] == tabla[1] && tabla[1] == tabla[2]) { allas = jatekos; } /*vízszintes ellenőrzés*/
                else if (tabla[3] == tabla[4] && tabla[4] == tabla[5]) { allas = jatekos; }
                else if (tabla[6] == tabla[7] && tabla[7] == tabla[8]) { allas = jatekos; }
                else if (tabla[0] == tabla[3] && tabla[3] == tabla[6]) { allas = jatekos; } /*függőleges ellenőrzés*/
                else if (tabla[1] == tabla[4] && tabla[4] == tabla[7]) { allas = jatekos; }
                else if (tabla[2] == tabla[5] && tabla[5] == tabla[8]) { allas = jatekos; }
                else if (tabla[0] == tabla[4] && tabla[4] == tabla[8]) { allas = jatekos; } /*átlós ellenőrzés*/
                else if (tabla[2] == tabla[4] && tabla[4] == tabla[6]) { allas = jatekos; }
                else { allas = 0; }
            }
            if (allas!=0)
            {
                lblUzenet.ForeColor = Color.DarkGreen;
                lblUzenet.Font = new Font(lblUzenet.Font, FontStyle.Bold);
                lblUzenet.Text = nev1 + " nyert! Gratulálok!";
                btn0.Enabled = false;
                btn1.Enabled = false;
                btn2.Enabled = false;
                btn3.Enabled = false;
                btn4.Enabled = false;
                btn5.Enabled = false;
                btn6.Enabled = false;
                btn7.Enabled = false;
                btn8.Enabled = false;
            }
            else
            {
                if (lepes==9)
                {
                    lblUzenet.ForeColor = Color.DarkGreen;
                    lblUzenet.Font = new Font(lblUzenet.Font, FontStyle.Bold);
                    lblUzenet.Text = "Döntetlen!";
                    btn0.Enabled = false;
                    btn1.Enabled = false;
                    btn2.Enabled = false;
                    btn3.Enabled = false;
                    btn4.Enabled = false;
                    btn5.Enabled = false;
                    btn6.Enabled = false;
                    btn7.Enabled = false;
                    btn8.Enabled = false;
                }
                else
                {
                    lblUzenet.Text = nev2 + " következik! (Jeled: " + jel2 + ".)";
                }
            }            
        }        
    }
}
